local mvec3_dir = mvector3.direction
local mvec3_dot = mvector3.dot
local math_max = math.max
local tmp_vec1 = Vector3()
local tmp_vec2 = Vector3()

function SentryGunBrain:_upd_fire(t)
	if not alive(self._unit) then
		return
	end

	if self._ext_movement:is_activating() or self._ext_movement:is_inactivating() or self._idle then
		if self._firing then
			self._unit:weapon():stop_autofire()

			self._firing = false
		end

		return
	end

	local target_is_visible = self._ext_movement:is_target_visible()

	self:_upd_abandon_turret(t, target_is_visible)

	if not target_is_visible and self._firing then
		self._unit:weapon():stop_autofire()

		self._firing = false
	end

	local attention = self._ext_movement:attention()

	if self._unit:weapon() and self._unit:weapon():out_of_ammo() then
		if self._unit:weapon():can_auto_reload() then
			if self._firing then
				self._unit:weapon():stop_autofire()

				self._firing = false
			end

			if not self._ext_movement:rearming() then
				self._ext_movement:rearm()
			end
		elseif not self._unit:base():waiting_for_refill() then
			self:switch_off()
		end
	elseif self._ext_movement:rearming() then
		self._ext_movement:complete_rearming()
	elseif attention and attention.reaction and AIAttentionObject.REACT_SHOOT <= attention.reaction and not self._ext_movement:warming_up(t) then
		local expend_ammo = Network:is_server()
		local damage_player = attention.unit:base() and attention.unit:base().is_local_player

		if self._firing then
			self._unit:weapon():trigger_held(false, expend_ammo, damage_player, attention.unit)
		else
			if attention.pos then
				mvec3_dir(tmp_vec1, self._ext_movement:m_head_pos(), attention.pos)
			elseif attention.unit:movement() then
				mvec3_dir(tmp_vec1, self._ext_movement:m_head_pos(), attention.unit:movement():m_com())
			else
				mvec3_dir(tmp_vec1, self._ext_movement:m_head_pos(), attention.handler:get_detection_m_pos())
			end

			local max_dot = self._tweak_data.KEEP_FIRE_ANGLE
			max_dot = math.min(0.99, 1 - (1 - max_dot) * (self._shaprness_mul or 1))

			if target_is_visible and max_dot < mvec3_dot(tmp_vec1, self._ext_movement:m_head_fwd()) then
				self._unit:weapon():start_autofire()
				self._unit:weapon():trigger_held(false, expend_ammo, damage_player, attention.unit)

				self._firing = true
				self._allow_turret_abandon = true
			end
		end
	elseif self._firing then
		self._unit:weapon():stop_autofire()

		self._firing = false
	end
end