Hooks:PostHook(TeamAIDamage, "damage_bullet", "teamai_dmg_voicelines", function(self, attack_data)
	if attack_data.result and attack_data.result.variant == "bullet" and attack_data.result.type ~= "none" then
		if attack_data.is_turret and attack_data.weapon_unit and attack_data.weapon_unit:weapon() and attack_data.weapon_unit:weapon()._puppet_unit then
			managers.dialog:queue_dialog("player_gen_mg_under_fire", {
				skip_idle_check = true,
				instigator = self._unit
			})
		else
			managers.dialog:queue_dialog("player_gen_taking_fire", {
				skip_idle_check = true,
				instigator = self._unit
			})
		end
	end
end)

function TeamAIDamage:revive(reviving_unit)
	if self._dead then
		return
	end

	self._revive_reminder_line_t = nil

	if self._bleed_out or self._fatal then
		self:_regenerated()

		local action_data = {
			variant = "stand",
			body_part = 1,
			type = "act",
			blocks = {
				heavy_hurt = -1,
				hurt = -1,
				action = -1,
				aim = -1,
				walk = -1
			}
		}
		local res = self._unit:movement():action_request(action_data)

		self._unit:interaction():set_active(false, false)
		self._unit:brain():on_recovered(reviving_unit)
		PlayerMovement.set_attention_settings(self._unit:brain(), {
			"team_enemy_cbt"
		}, "team_AI")
		self._unit:network():send("from_server_unit_recovered")
		managers.groupai:state():on_criminal_recovered(self._unit)
	elseif self._arrested_timer then
		self._arrested_timer = nil
		local action_data = {
			variant = "stand",
			body_part = 1,
			type = "act",
			blocks = {
				heavy_hurt = -1,
				hurt = -1,
				action = -1,
				aim = -1,
				walk = -1
			}
		}
		local res = self._unit:movement():action_request(action_data)

		self._unit:brain():on_recovered(reviving_unit)
		PlayerMovement.set_attention_settings(self._unit:brain(), {
			"team_enemy_cbt"
		}, "team_AI")
		self._unit:network():send("from_server_unit_recovered")
		managers.groupai:state():on_criminal_recovered(self._unit)
	end

	managers.hud:on_teammate_revived(self._unit:unit_data().teammate_panel_id, self._unit:unit_data().name_label_id)
	managers.dialog:queue_dialog("player_gen_revive_thanks", {
		skip_idle_check = true,
		instigator = reviving_unit
	})
end